@rem
@rem RatheDG Cachalot System 1.2.0. ERU server stop script.
@rem
@rem Note:
@rem    1) System parameters marked as (!) MUST be configured by deployer.
@rem       System will not work if these parameters are not defined properly.
@rem
@rem    2) System parameters marked as (S) are important for system security.
@rem       It is recommended to configure them after initial system installation
@rem       and configuration.
@rem

@echo off

rem
rem (!) %SERVER% is host where ERU server is running.
rem See 'address' parameter in erus.conf.
rem
set SERVER=MyERUServer

rem
rem %PORT% is port which ERU server is listening to.
rem See 'port' parameter in erus.conf.
rem
set PORT=9008

rem
rem (S) %PASSWORD% is password to authenticate in ERU server.
rem See 'shutdown.password' parameter in erus.conf.
rem
set PASSWORD=MyERUShutdownPassword

if not defined CACHALOT_HOME set CACHALOT_HOME=%~dp0..

set ENV=%CACHALOT_HOME%\bin\environment.cmd
if exist "%ENV%" goto ENV
    echo Can't find file: %ENV%.
    echo This file is needed to run this program.
    goto :EOF
:ENV

call "%ENV%"

%JAVA% com.rathedg.socketserver.Shutdown %SERVER% %PORT% %PASSWORD%

